// ---------------------------------------------------------------------------------- //
//                          Don't forget to donate. ;-)                               //
//                                                                                    //
//                      PayPal: blubbb@digital-filestore.de or                        //
// https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=6V328N8PQ753C //
//                                                                                    //
//        It's mainly for motivation. ;-) Do it if you find the stuff useful!         //
// ---------------------------------------------------------------------------------- //

#property copyright "blubbb@digital-filestore.de"
#property link      "https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=6V328N8PQ753C"

#property indicator_chart_window

extern int MaxDistance = 10;
extern int PsychInterval = 25;
extern string Voice = "";

double Old = 0;
double P;

double GetRealPoint() {
  switch (Digits) {
    case 3: return(0.01);
    case 5: return(0.0001);
  }
  return(Point);
}

int init() {
  P = GetRealPoint();
/*
  if (Voice == "") {
    if (Symbol() == "EURUSD") Voice = "a";
    if (Symbol() == "USDJPY") Voice = "b";
    if (Symbol() == "EURJPY") Voice = "c";
  }
*/
  return(0);
}

int deinit() {
  ObjectDelete("bpal");
  ObjectDelete("bpas");
  return(0);
}

void SpeakPipDiff(double d) {
  static string old = "";
  string s = DoubleToStr(d / P, 0);
  if (old == s) return(0);
  PlaySound(s+Voice+".wav");
  old = s;
  return(0);
}

void SpeakGo() {
  PlaySound("go"+Voice+".wav");
  return(0);
}

int start() {
  double op = iOpen(NULL, PERIOD_H1, 0);
  double cl = Close[0];
  double hi = iHigh(NULL, PERIOD_H1, 0);
  double lo = iLow(NULL, PERIOD_H1, 0);
  double b1 = iClose(NULL, PERIOD_H1, 1) - iOpen(NULL, PERIOD_H1, 1);
  double short = MathFloor(op / PsychInterval / P) * PsychInterval * P;
  double long = short + PsychInterval * P;

  if (Old > 0) {
    if (/*(b1 < 0) &&*/ (cl <= long) && (hi <= long) && (long - cl <= MaxDistance * P) && (cl > Old)) SpeakPipDiff(long - cl);
    if (/*(b1 > 0) &&*/ (cl >= short) && (lo >= short) && (cl - short <= MaxDistance * P) && (cl < Old)) SpeakPipDiff(cl - short);
    if (/*(b1 < 0) &&*/ (cl > long) && (Old <= long) && (cl == hi)) SpeakGo();
    if (/*(b1 > 0) &&*/ (cl < short) && (Old >= short) && (cl == lo)) SpeakGo();
  }
  
  Old = cl;

  static int lasthour = -1;
  int hour = TimeHour(TimeCurrent());
  if (hour == lasthour) return(0);

  string n = "bpas";
//  if (b1 > 0) {
    ObjectCreate(n, OBJ_HLINE, 0, 0, 0);
    ObjectSet(n, OBJPROP_PRICE1, short);
    ObjectSet(n, OBJPROP_COLOR, Red);
    ObjectSet(n, OBJPROP_STYLE, STYLE_DOT);
//  } else ObjectDelete(n);

  n = "bpal";
//  if (b1 < 0) {
    ObjectCreate(n, OBJ_HLINE, 0, 0, 0);
    ObjectSet(n, OBJPROP_PRICE1, long);
    ObjectSet(n, OBJPROP_COLOR, Lime);
    ObjectSet(n, OBJPROP_STYLE, STYLE_DOT);
//  } else ObjectDelete(n);
  
  return(0);
}

